<?php namespace App\Models\Admin;

use App\Models\Project\DatatableModel;

class TestimonialModel extends AdminModel{
	private $table; 
	
    public function __construct(){
		parent::__construct();
		$this->table = "testimonial";
    }

	public function get_datatable(){
		$dtObj = new DatatableModel($this->db);
		$dtObj->set_table($this->table." AS mt");
		// Set Datatable columns 
		$dtObj->set_column('mt.testimonial_id', 'desc|sort|search', 'RecordID');
		$dtObj->set_column('mt.status', 'sort|search');
		$dtObj->set_column('ln.name', 'sort|search');
		$builder = $dtObj->get_builder();
		$builder->join($this->table."_ln AS ln","mt.testimonial_id=ln.testimonial_id AND ln.language_code='".$this->project->default_lang_code."'",'left');
		$builder->where('mt.is_deleted','No');
		return $dtObj->get_data($builder);
	} 
	
	public function get($language_list,$testimonial_id){
		$builder = $this->db->table($this->table." AS mt");
		$columns = ["mt.*"];
		$ln_columns = ['testimonial_ln_id',
			'name',
			'city',
			'description',
			'language_code'];
		if($language_list){
			foreach($language_list as $language){
				foreach($ln_columns as $col_name){
					array_push($columns,$language['code'].".".$col_name." AS ".$col_name."_".$language['code']);
				}
				$builder->join($this->table."_ln AS ".$language['code'],"mt.testimonial_id=".$language['code'].".testimonial_id AND ".$language['code'].".language_code='".$language['code']."'",'left');
			}
		}
		$builder->select(implode(", ",$columns));
		$builder->where('mt.testimonial_id',$testimonial_id);
		$query = $builder->get();
		//echo $builder->getCompiledSelect();
		return $query->getRowArray();
	}
	
	public function insert($data){
		$this->add_insert_log($data);
		$builder = $this->db->table($this->table);
		$builder->insert($data);
		return $this->db->insertID();
	}
	
	public function update($data, $testimonial_id){
		$this->add_update_log($data);
		$builder = $this->db->table($this->table);
		$builder->where('testimonial_id',$testimonial_id);
		$builder->update($data);
	}
	
	public function delete($testimonial_id){
		$data['is_deleted'] = "Yes";
		$this->add_update_log($data);
		$builder = $this->db->table($this->table);
		$builder->where('testimonial_id',$testimonial_id)
				->update($data);
	}
	
	public function is_unique_testimonial_url($url,$testimonial_id){
		$builder = $this->db->table($this->table);
		$builder->where('is_deleted','No')
			->where('testimonial_url',$url);
		if($testimonial_id!=""){
			$builder->where('testimonial_id!=',$testimonial_id);
		}
		$query = $builder->get();
		if($query->getRowArray()){
			$response = "FALSE|The testimonial url already exist!";
		}else{
			$response = "TRUE|";
		}
		return $response;
	}
	
	public function update_language_data($data,$testimonial_ln_id){
		$builder = $this->db->table($this->table.'_ln');
		$builder->where('testimonial_ln_id',$testimonial_ln_id)
		->update($data);
	}
	
	public function insert_language_data($data){
		$builder = $this->db->table($this->table.'_ln');
		$builder->insert($data);
	}
}